#include <stdbool.h>

typedef struct pile pile;

pile *creer_pile(); // crée une nouvelle pile vide
bool pile_est_vide(pile *p); // teste si p est la pile vide
void empiler(pile *p, int val); // empile val au sommet de p
int sommet(pile *p); // renvoie le sommet de p (p doit être non vide)
int depiler(pile *p); // dépile l'élément au sommet de p (non vide) et le renvoie
void detruire_pile(pile *p); // libère p de la mémoire
