#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>
#include <string.h>
#include "pile.h"

/*** Exercice 2 ***/

/* Question 3 et 4 */

/* On obtient 3+4*5-2*6 pour chacun des arbres */

/* Question 5 */

/* Dans l'ordre de l'ennoncé :
   34+526*-*
   345*+26*-
   345*26*-+ 
*/

/*** Exercice 3 ***/

int nb(char n)
{
  assert('0' <= n && n <= '9');
  return (int)(n - '0');
}

int operation(char op, int a, int b)
{
  if (op == '+') { return a + b; }
  else if (op == '-') { return a - b; }
  else if (op == '*') { return a * b; }
  else { return a / b; }
}

int polonaise(char *expr)
{
  pile *p = creer_pile();
  int n = strlen(expr);
  for (int i = 0; i < n; i++)
  {
    char c = expr[i];
    if ('0' <= c && c <= '9')
    {
      empiler(p, nb(c));
    }
    else
    {
      int b = depiler(p);
      int a = depiler(p);
      int res = operation(c, a, b);
      empiler(p, res);
    }
  }
  int res = depiler(p);
  assert(pile_est_vide(p));
  detruire_pile(p);
  return res;
}

int main()
{
  char s1[] = "34+526*-*";
  char s2[] = "345*+26*-";
  char s3[] = "345*26*-+"; 
  printf("%d\n", polonaise(s1));
  printf("%d\n", polonaise(s2));
  printf("%d\n", polonaise(s3));
}
